## kokkos 4.3.01

=== simd/CMakeLists.txt ===
IF (NOT Kokkos_INSTALL_TESTING)
  ADD_SUBDIRECTORY(src)
ENDIF()

KOKKOS_ADD_TEST_DIRECTORIES(unit_tests)
