=== benchmarks/atomic/CMakeLists.txt ===
KOKKOS_ADD_EXECUTABLE(
  atomic
  SOURCES main.cpp
)
