=== example/tutorial/Advanced_Views/04_dualviews/CMakeLists.txt ===

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

# This is a tutorial, not a test, so we don't ask CTest to run it.
KOKKOS_ADD_EXECUTABLE(
  tutorial_advancedviews_04_dualviews
  SOURCES dual_view.cpp
)
