=== debian/changelog ===
kokkos (4.3.01-1) unstable; urgency=medium

  * New upstream version.
  * Ack NMU.
  * d/patches: dropped as upstreamed.
  * Bump standards version to 4.7.0.
  * d/copyright: bump years.
  * d/control: adapted for new version.

 -- Alex Myczko <tar@debian.org>  Sun, 02 Jun 2024 21:29:57 +0000
